/* Zaklady programovani v C++
   Cviceni 6-7, 17-23.10.2018
   Okomentovane priklady ze cviceni ... REKURZE a minule domci ulohy
*/

#include<iostream>
using namespace std;

///////////////////////////////////////////////////////////////
// Rekurze
///////////////////////////////////////////////////////////////

/* Funkce spocita a vrati faktorial prirozeneho cisla n. */
long long faktorial2(int n)
{
	if (n <= 0)
		return 1;
	return n*faktorial2(n-1);
}

/* Funkce spocita a vrati hodnotu x^n (n je prirozene cislo). */
double mocnina2(double x, int n)
{
	if (n <= 0)
		return 1;
	return x*mocnina2(x,n-1);
}

/* Funkce spocita a vrati n-t len fibonacciho posloupnosti (n je prirozene cislo). 
   Rekurzivni funkce.
*/
int fibonacci(int n)
{
	if (n <= 0)
		return 0;
	if (n == 1)
		return 1;
	return fibonacci(n-1)+fibonacci(n-2);
}

/* Funkce spocita a vrati n-t len fibonacciho posloupnosti (n je prirozene cislo).
   een bez rekurze.
*/
int fibonacci1(int n)
{
	if (n <= 0)
		return 0;
	if (n == 1)
		return 1;
	int f0=0, f1=1, vysledek; // predchozi dva cleny posloupnosti, aktualni clen
	for (int i = 2; i <= n; i++)
	{
		vysledek = f0 + f1;
		f0 = f1;
		f1 = vysledek;
	}
	return vysledek;
}

///////////////////////////////////////////////////////////////
// Minule domaci ulohy
///////////////////////////////////////////////////////////////


/* Funkce spocita a vrati ciferny soucet prirozeneho cisla n.
*/
int ciferny_soucet(int n)
{
	int vysledek = 0;
	while (n > 0)
	{
		vysledek += n % 10;
		n /= 10;
	}
	return vysledek;

}

/* Funkce nacita cisla z konzole a vrati jejich soucet. Pokud uzivatel udela preklep, 
   pozada ho, aby zadal cislo znova.
*/
int secti_cisla()
{
	int cislo, soucet = 0;
	cout << "Zadavej cisla, ktera chces secist (konec ... 0): "<< endl;
	do
	{
		cout << "zadej cislo: ";
		if (!(cin >> cislo))
		{
			cin.clear();
			cin.ignore(256, '\n');
			cout << "Zadany vstup neni cele cislo. Zkus to znovu." << endl;
			cislo = 1;
			continue;
		}
		soucet += cislo;
	} while (cislo != 0); 
	return soucet;
}

/* Funkce nacte z konzole cislo v danem rozsahu hodnot.  */
int nacti_cislo(int minimum, int maximum)
{
	int n;
	while (true)    // for(;;)
	{
		cout << "Zadej cele cislo od " << minimum << " do " << maximum << " : ";
		if (!(cin >> n))
		{
			cin.clear();
			cin.ignore(256, '\n');
			cout << "Zadany vstup neni cele cislo. Zkus to znovu. " << endl;
			continue;
		}
		if (n >= minimum && n <= maximum)
		{
			break; // povedlo se
		}
		cout << "Neplatne zadani. Zkus to znovu!" << endl;
	}
	return n;
}


//int mainRekurze()
int main()
{
	int n;

    // Faktorial
	cout << "***** Vypocet faktorialu ******\n";
	n = nacti_cislo(0, 20);
	cout << "Faktorial cisla " << n << " je " << faktorial2(n) << endl;

	// Mocnina
	cout << "\n***** Vypocet mocniny ******\n";
	cout << "Zadej prirozene cislo (mocnitel): ";
	cin >> n;
	cout << "Zadej realne cislo (mocnenec): ";
	double x;
	cin >> x;
	cout << "Mocnina je " << mocnina2(x, n) << endl;

	// Fibonacci
	cout << "\nFibonacciho posloupnost (rekurzivne): " << endl;
	for (n = 0; n < 20; n++)
	{
		cout << fibonacci(n) << " ";
	}
	cout << "\nFibonacciho posloupnost (bez rekurze): " << endl;
	for (n = 0; n < 20; n++)
	{
		cout << fibonacci1(n) << " ";
	}
	cout << '\n'; // endl

	// Ciferny soucet:
	cout << "\n***** Vypocet ciferneho souctu ******\n";
	cout << "Zadej prirozene cislo: ";
	cin >> n;
	cout << "Ciferny soucet cisla " << n << " je " << ciferny_soucet(n) << endl;

	// secti cisla:
	cout << "\n***** Soucet cisel zadanych uzivatelem ******\n";
	cout << "Soucet zadanych cisel je " << secti_cisla() << endl;

 return 0;
}