/* Zaklady programovani v C++
   Cviceni 7, 23.10.2018
   Okomentovane priklady ze cviceni ... znaky
*/
#include<iostream>
using namespace std;

/* Pokud je znak male pismeno, funkce ho prevede na velke pismeno, jinak ho necha beze zmeny. */
char na_velke(char znak)
{
	if (znak >= 'a' && znak <= 'z')
		znak -= ('a' - 'A');
	return znak;
}

/* Pokud je znak velke pismeno, funkce ho prevede na male pismeno, jinak ho necha beze zmeny. */
char na_male(char znak)
{
	if (znak >= 'A' && znak <= 'Z')
		znak += ('a' - 'A');
	return znak;
}

/* Funkce vypise na konzoli informace o znaku a jeho ASCII kod. */
void vypis_o_znaku(char znak)
{
	cout << "Znak " << znak;
	if (znak >= 'a' && znak <= 'z')
		cout << " je male pismeno.";
	else if (znak >= 'A' && znak <= 'Z')
		cout << " je velke pismeno.";
	else if (znak >= '0' && znak <= '9')
		cout << " je cislice.";
	else
		cout << " je jiny typ znaku.";
	cout << " Jeho ASCII kod je " << (int)znak << endl;

}

/* Funkce postupne nacte cely radek textu a zmeni v nem mala pismena na velka. Vysledek vypise na konzoli. */
void cely_radek()
{
	cout << "Zadej radek textu:" << endl;
	char znak;
	do
	{
		znak = getchar();
		cout << na_velke(znak);
	} while (znak != '\n');
}

/* Funkce postupne nacte cely radek textu a zmeni v nem mala pismena na velka. Vysledek vypise na konzoli. */
void cely_radek0()
{
	cout << "Zadej radek textu:" << endl;
	char znak;
	while (true)
	{
		znak = getchar();
		cout << na_velke(znak);;
		if (znak == '\n')
			break;
	}
}

/* Funkce vytiskne na konzoli sachovnici. */
void sachovnice()
{
	char bilePolicko = 219;
	char cernePolicko = 176;
	cout << endl;
	for (int i = 0; i < 8; i++)
	{
		for (int j = 0; j < 8; j++)
		{
			if (j % 2 == i % 2)
			{
				cout << bilePolicko << bilePolicko;
			}
			else
			{
				cout << cernePolicko << cernePolicko;
			}
		}
		cout << endl;
	}
	cout << endl;
}


//int mainZnaky()
int main()
{
	// Priklady ze cviceni:
	cout << "****** Vypis informaci o znaku ******" << endl;
	vypis_o_znaku('f');
	vypis_o_znaku('Z');
	vypis_o_znaku('4');
	vypis_o_znaku('\n');

	cout << "\n\n****** Mala a velka pismena ******" << endl;
	char znak = na_male('F');
	cout << znak;
	cout << na_male('G') << na_male(' ') << na_male('h') << na_male('1') << na_male('\n');
	cout << na_velke(znak) << na_velke('G') << na_velke(' ') << na_velke('h') << na_velke('1') << na_velke('\n');

	cout << "\n****** Prevod celeho radku textu na mala pismena ******" << endl;
	cely_radek();

	cout << "\n******  Sachovnice ******" << endl;
	sachovnice();

	cout << "\n******  ASCII tabulka ******" << endl;
	{
		for (unsigned char c = 33; c <= 255 && c > 0; c++)
		{
			cout << (int)c << " " << c << '\t';
		}
	}
	cout << '\n';

	// Ukazky prace se znaky
	{
		cout << "\n******  Jednoduche ukazky prace se znaky ******" << endl;
		char a = 'a';
		char b = 97;
		char c = '\x61';
		int x = a;
		cout << a << b << c << ' ' << x << " " << (int)a << '\n';
		putchar(' ');
		putchar('a');


		a += 8;
		if (a >= 'a')
			a = 'A' + 8;

		a = ' ';
		a = '\n';
		a = '\t';
		a = '\0';
		a = '\'';
		a = '\"';
		a = '\\';

		cout << "\nZadej posloupnost znaku 'ab cd ef' (vcetne mezer): ";
		cin >> a >> b >> c;
		cout << a << b << c << '\n';

		a = getchar();
		b = getchar();
		c = getchar();
		cout << a << b << c << '\n';
	}

	return 0;
}
